<?php

/*********************************************************************

 アンソロジー執筆者管理プラグイン (2012/11/22)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

/* メイン処理 */
function freo_page_anthology()
{
	global $freo;

	switch ($_REQUEST['freo']['work']) {
		case 'setup':
			freo_page_anthology_setup();
			break;
		case 'setup_execute':
			freo_page_anthology_setup_execute();
			break;
		case 'admin':
			freo_page_anthology_admin();
			break;
		case 'admin_form':
			freo_page_anthology_admin_form();
			break;
		case 'admin_post':
			freo_page_anthology_admin_post();
			break;
		case 'admin_delete':
			freo_page_anthology_admin_delete();
			break;
		default:
			freo_page_anthology_default();
	}

	return;
}

/* セットアップ */
function freo_page_anthology_setup()
{
	global $freo;

	//ログイン状態確認
	if ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author') {
		freo_redirect('login', true);
	}

	//リクエストメソッドに応じた処理を実行
	if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		//ワンタイムトークン確認
		if (!freo_token('check')) {
			$freo->smarty->append('errors', '不正なアクセスです。');
		}

		//エラー確認
		if (!$freo->smarty->get_template_vars('errors')) {
			freo_redirect('anthology/setup_execute?freo%5Btoken%5D=' . freo_token('create'), true);
		}
	}

	//データ割当
	$freo->smarty->assign(array(
		'token'       => freo_token('create'),
		'plugin_id'   => 'anthology',
		'plugin_name' => FREO_PLUGIN_ANTHOLOGY_NAME
	));

	//データ出力
	freo_output('plugins/setup.html');

	return;
}

/* セットアップ | セットアップ実行 */
function freo_page_anthology_setup_execute()
{
	global $freo;

	//ログイン状態確認
	if ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author') {
		freo_redirect('login', true);
	}

	//ワンタイムトークン確認
	if (!freo_token('check')) {
		freo_redirect('setup?error=1', true);
	}

	//データベーステーブル存在検証
	if (FREO_DATABASE_TYPE == 'mysql') {
		$query = 'SHOW TABLES';
	} else {
		$query = 'SELECT name FROM sqlite_master WHERE type = \'table\'';
	}
	$stmt = $freo->pdo->query($query);
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	$table = array();
	while ($data = $stmt->fetch(PDO::FETCH_NUM)) {
		$table[$data[0]] = true;
	}

	//データベーステーブル定義
	if (FREO_DATABASE_TYPE == 'mysql') {
		$queries = array(
			'plugin_anthologys' => '(id INT UNSIGNED NOT NULL AUTO_INCREMENT, created DATETIME NOT NULL, modified DATETIME NOT NULL, penname VARCHAR(255) NOT NULL, kana VARCHAR(255) NOT NULL, circle VARCHAR(255), url TEXT, imageurl TEXT, tag VARCHAR(255), text TEXT, PRIMARY KEY(id))'
		);
	} else {
		$queries = array(
			'plugin_anthologys' => '(id INTEGER, created DATETIME NOT NULL, modified DATETIME NOT NULL, penname VARCHAR NOT NULL, kana VARCHAR NOT NULL, circle VARCHAR, url TEXT, imageurl TEXT, tag VARCHAR, text TEXT, PRIMARY KEY(id))'
		);
	}

	//データベーステーブル作成
	foreach ($queries as $name => $query) {
		if (empty($table[FREO_DATABASE_PREFIX . $name])) {
			$stmt = $freo->pdo->query('CREATE TABLE ' . FREO_DATABASE_PREFIX . $name . $query);
			if (!$stmt) {
				freo_error($freo->pdo->errorInfo());
			}
		}
	}

	//ログ記録
	freo_log(FREO_PLUGIN_ANTHOLOGY_NAME . 'のセットアップを実行しました。');

	//完了画面へ移動
	freo_redirect('anthology/setup?exec=setup', true);

	return;
}

/* 管理画面 | 執筆者管理 */
function freo_page_anthology_admin()
{
	global $freo;

	//ログイン状態確認
	if ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author') {
		freo_redirect('login', true);
	}

	//パラメータ検証
	if (!isset($_GET['page']) or !preg_match('/^\d+$/', $_GET['page']) or $_GET['page'] < 1) {
		$_GET['page'] = 1;
	}

	//検索条件設定
	$condition = null;
	if (isset($_GET['word'])) {
		$condition .= ' AND penname LIKE ' . $freo->pdo->quote('%' . $_GET['word'] . '%') . ' OR text LIKE ' . $freo->pdo->quote('%' . $_GET['word'] . '%');
	}
	if (isset($_GET['tag'])) {
		$condition .= ' AND tag = ' . $freo->pdo->quote($_GET['tag']) . ' OR tag LIKE ' . $freo->pdo->quote($_GET['tag'] . ',%') . ' OR tag LIKE ' . $freo->pdo->quote('%,' . $_GET['tag']) . ' OR tag LIKE ' . $freo->pdo->quote('%,' . $_GET['tag'] . ',%');
	}
	if (isset($_GET['date'])) {
		if (preg_match('/^\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		} elseif (preg_match('/^\d\d\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y%m\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y%m\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		} elseif (preg_match('/^\d\d\d\d\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y%m%d\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y%m%d\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		}
	}
	if ($condition) {
		$condition = ' WHERE id IS NOT NULL ' . $condition;
	}

	//執筆者取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_anthologys ' . $condition . ' ORDER BY id DESC LIMIT :start, :limit');
	$stmt->bindValue(':start', intval($freo->config['plugin']['anthology']['admin_limit']) * ($_GET['page'] - 1), PDO::PARAM_INT);
	$stmt->bindValue(':limit', intval($freo->config['plugin']['anthology']['admin_limit']), PDO::PARAM_INT);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_anthologys = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_anthologys[$data['id']] = $data;
	}

	//執筆者数・ページ数取得
	$stmt = $freo->pdo->query('SELECT COUNT(*) FROM ' . FREO_DATABASE_PREFIX . 'plugin_anthologys ' . $condition);
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	$data                  = $stmt->fetch(PDO::FETCH_NUM);
	$plugin_anthology_count = $data[0];
	$plugin_anthology_page  = ceil($plugin_anthology_count / $freo->config['plugin']['anthology']['admin_limit']);

	//データ割当
	$freo->smarty->assign(array(
		'token'                 => freo_token('create'),
		'plugin_anthologys'      => $plugin_anthologys,
		'plugin_anthology_count' => $plugin_anthology_count,
		'plugin_anthology_page'  => $plugin_anthology_page
	));

	return;
}

/* 管理画面 | 執筆者入力 */
function freo_page_anthology_admin_form()
{
	global $freo;

	//ログイン状態確認
	if ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author') {
		freo_redirect('login', true);
	}

	//パラメータ検証
	if (!isset($_GET['id']) or !preg_match('/^\d+$/', $_GET['id']) or $_GET['id'] < 1) {
		$_GET['id'] = 0;
	}

	//リクエストメソッドに応じた処理を実行
	if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		//ワンタイムトークン確認
		if (!freo_token('check')) {
			$freo->smarty->append('errors', '不正なアクセスです。');
		}

		//入力データ検証
		if (!$freo->smarty->get_template_vars('errors')) {
			//ペンネーム
			if ($_POST['plugin_anthology']['penname'] == '') {
				$freo->smarty->append('errors', 'ペンネームが入力されていません。');
			} elseif (mb_strlen($_POST['plugin_anthology']['penname'], 'UTF-8') > 80) {
				$freo->smarty->append('errors', 'ペンネームは80文字以内で入力してください。');
			}

			//フリガナ
			if ($_POST['plugin_anthology']['kana'] == '') {
				$freo->smarty->append('errors', 'フリガナが入力されていません。');
			} elseif (mb_strlen($_POST['plugin_anthology']['kana'], 'UTF-8') > 80) {
				$freo->smarty->append('errors', 'フリガナは80文字以内で入力してください。');
			} elseif (!preg_match('/^[ァ-ヶー]+$/u', $_POST['plugin_anthology']['kana'])) {
				$freo->smarty->append('errors', 'フリガナは全角カタカナで入力してください。');
			}

			//URL
			if ($_POST['plugin_anthology']['url'] == '') {
				$freo->smarty->append('errors', 'URLが入力されていません。');
			} elseif (mb_strlen($_POST['plugin_anthology']['url'], 'UTF-8') > 5000) {
				$freo->smarty->append('errors', 'URLは5000文字以内で入力してください。');
			}

			//URL
			if (mb_strlen($_POST['plugin_anthology']['imageurl'], 'UTF-8') > 5000) {
				$freo->smarty->append('errors', 'バナーURLは5000文字以内で入力してください。');
			}

			//タグ
			if (mb_strlen($_POST['plugin_anthology']['tag'], 'UTF-8') > 80) {
				$freo->smarty->append('errors', 'タグは80文字以内で入力してください。');
			}

			//本文
			if (mb_strlen($_POST['plugin_anthology']['text'], 'UTF-8') > 5000) {
				$freo->smarty->append('errors', '本文は5000文字以内で入力してください。');
			}
		}

		//エラー確認
		if ($freo->smarty->get_template_vars('errors')) {
			//エラー表示
			$plugin_anthology = $_POST['plugin_anthology'];
		} else {
			$_SESSION['input'] = $_POST;

			//登録処理へ移動
			freo_redirect('anthology/admin_post?freo%5Btoken%5D=' . freo_token('create') . ($_GET['id'] ? '&id=' . $_GET['id'] : ''));
		}
	} else {
		if ($_GET['id']) {
			//編集データ取得
			$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_anthologys WHERE id = :id');
			$stmt->bindValue(':id', $_GET['id'], PDO::PARAM_INT);
			$flag = $stmt->execute();
			if (!$flag) {
				freo_error($stmt->errorInfo());
			}

			if ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$plugin_anthology = $data;
			} else {
				freo_error('指定された執筆者が見つかりません。');
			}
		} else {
			//新規データ設定
			$plugin_anthology = array();
		}
	}

	//データ割当
	$freo->smarty->assign(array(
		'token' => freo_token('create'),
		'input' => array(
			'plugin_anthology' => $plugin_anthology
		)
	));

	return;
}

/* 管理画面 | 執筆者登録 */
function freo_page_anthology_admin_post()
{
	global $freo;

	//ログイン状態確認
	if ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author') {
		freo_redirect('login', true);
	}

	//入力データ確認
	if (empty($_SESSION['input'])) {
		freo_redirect('anthology/admin?error=1');
	}

	//ワンタイムトークン確認
	if (!freo_token('check')) {
		freo_redirect('anthology/admin?error=1');
	}

	//入力データ取得
	$anthology = $_SESSION['input']['plugin_anthology'];

	if ($anthology['tag'] == '') {
		$anthology['tag'] = null;
	}
	if ($anthology['text'] == '') {
		$anthology['text'] = null;
	}

	//データ登録
	if (isset($_GET['id'])) {
		$stmt = $freo->pdo->prepare('UPDATE ' . FREO_DATABASE_PREFIX . 'plugin_anthologys SET modified = :now, penname = :penname, kana = :kana, circle = :circle, url = :url, imageurl = :imageurl, tag = :tag, text = :text WHERE id = :id');
		$stmt->bindValue(':now',      date('Y-m-d H:i:s'));
		$stmt->bindValue(':penname',  $anthology['penname']);
		$stmt->bindValue(':kana',     $anthology['kana']);
		$stmt->bindValue(':circle',   $anthology['circle']);
		$stmt->bindValue(':url',      $anthology['url']);
		$stmt->bindValue(':imageurl',      $anthology['imageurl']);
		$stmt->bindValue(':tag',      $anthology['tag']);
		$stmt->bindValue(':text',     $anthology['text']);
		$stmt->bindValue(':id',       $anthology['id'], PDO::PARAM_INT);
		$flag = $stmt->execute();
		if (!$flag) {
			freo_error($stmt->errorInfo());
		}
	} else {
		$stmt = $freo->pdo->prepare('INSERT INTO ' . FREO_DATABASE_PREFIX . 'plugin_anthologys VALUES(NULL, :now1, :now2, :penname, :kana, :circle, :url, :imageurl, :tag, :text)');
		$stmt->bindValue(':now1',  date('Y-m-d H:i:s'));
		$stmt->bindValue(':now2',  date('Y-m-d H:i:s'));
		$stmt->bindValue(':penname', $anthology['penname']);
		$stmt->bindValue(':kana', $anthology['kana']);
		$stmt->bindValue(':circle', $anthology['circle']);
		$stmt->bindValue(':url',   $anthology['url']);
		$stmt->bindValue(':imageurl',   $anthology['imageurl']);
		$stmt->bindValue(':tag',   $anthology['tag']);
		$stmt->bindValue(':text',  $anthology['text']);
		$flag = $stmt->execute();
		if (!$flag) {
			freo_error($stmt->errorInfo());
		}
	}

	//入力データ破棄
	$_SESSION['input'] = array();

	//ログ記録
	if (isset($_GET['id'])) {
		freo_log('執筆者を編集しました。');
	} else {
		freo_log('執筆者を新規に登録しました。');
	}

	//執筆者管理へ移動
	if (isset($_GET['id'])) {
		freo_redirect('anthology/admin?exec=update&id=' . $anthology['id']);
	} else {
		freo_redirect('anthology/admin?exec=insert');
	}

	return;
}

/* 管理画面 | 執筆者削除 */
function freo_page_anthology_admin_delete()
{
	global $freo;

	//ログイン状態確認
	if ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author') {
		freo_redirect('login', true);
	}

	//パラメータ検証
	if (!isset($_GET['id']) or !preg_match('/^\d+$/', $_GET['id']) or $_GET['id'] < 1) {
		freo_redirect('anthology/admin?error=1');
	}

	//ワンタイムトークン確認
	if (!freo_token('check')) {
		freo_redirect('anthology/admin?error=1');
	}

	//執筆者削除
	$stmt = $freo->pdo->prepare('DELETE FROM ' . FREO_DATABASE_PREFIX . 'plugin_anthologys WHERE id = :id');
	$stmt->bindValue(':id', $_GET['id'], PDO::PARAM_INT);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	//連番リセット
	if (FREO_DATABASE_TYPE == 'mysql') {
		$stmt = $freo->pdo->query('ALTER TABLE ' . FREO_DATABASE_PREFIX . 'plugin_anthologys AUTO_INCREMENT = 0');
		if (!$stmt) {
			freo_error($freo->pdo->errorInfo());
		}
	}

	//ログ記録
	freo_log('執筆者を削除しました。');

	//執筆者管理へ移動
	freo_redirect('anthology/admin?exec=delete&id=' . $_GET['id']);

	return;
}

/* 執筆者一覧 */
function freo_page_anthology_default()
{
	global $freo;

	//検索条件設定
	$condition = null;
	if (isset($_GET['word'])) {
		$condition .= ' AND penname LIKE ' . $freo->pdo->quote('%' . $_GET['word'] . '%') . ' OR text LIKE ' . $freo->pdo->quote('%' . $_GET['word'] . '%');
	}
	if (isset($_GET['tag'])) {
		$condition .= ' AND tag = ' . $freo->pdo->quote($_GET['tag']) . ' OR tag LIKE ' . $freo->pdo->quote($_GET['tag'] . ',%') . ' OR tag LIKE ' . $freo->pdo->quote('%,' . $_GET['tag']) . ' OR tag LIKE ' . $freo->pdo->quote('%,' . $_GET['tag'] . ',%');
	}
	if ($condition) {
		$condition = ' WHERE id IS NOT NULL ' . $condition;
	}


	//執筆者取得
	$stmt = $freo->pdo->query('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_anthologys ' . $condition . ' ORDER BY kana');	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}
	$plugin_anthologys = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_anthologys[$data['id']] = $data;
	}

	//執筆者ID取得
	$plugin_anthology_keys = array_keys($plugin_anthologys);

	//執筆者タグ取得
	$plugin_anthology_tags = array();
	foreach ($plugin_anthology_keys as $plugin_anthology) {
		if (!$plugin_anthologys[$plugin_anthology]['tag']) {
			continue;
		}

		$plugin_anthology_tags[$plugin_anthology] = explode(',', $plugin_anthologys[$plugin_anthology]['tag']);
	}

	$data                  = $stmt->fetch(PDO::FETCH_NUM);
	$plugin_anthology_count = $data[0];

	//データ割当
	$freo->smarty->assign(array(
		'token'                 => freo_token('create'),
		'plugin_anthologys'      => $plugin_anthologys,
		'plugin_anthology_tags'  => $plugin_anthology_tags,
		'plugin_anthology_count' => $plugin_anthology_count
	));

	return;
}

?>
